/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package sample.tswebclient.servlet;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import sample.tswebclient.bean.ApplicationTreeBean;
import sample.tswebclient.cassandra.Application;

/**
 *
 * @author ricky
 */
public class ImageServlet extends FileServlet {
    
    /**
     * Logger for the class
     */
    private static final Logger logger = LoggerFactory.getLogger(ImageServlet.class);
        
    /**
     * The application tree bean
     */
    @javax.inject.Inject
    private ApplicationTreeBean applicationTree;
    
    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        logger.info("Enetring processRequest");
        try {
            String key = request.getParameter("key");
            logger.info("Key received: " + key);
            Application app = this.applicationTree.getApplication(key);
            if (app != null && app.getIcon() != null && app.getIcon().length > 0) {
                this.processByteArray(request, response, app.getName() + ".png", 
                        app.getIcon(), app.getWriteIconTimestamp());
            
            } else {
                throw new ServletException("Invalid image!");
            }
        } catch (IOException e) {
            logger.error("Error returning file.", e);
            throw e;
        }
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Image servlet";
    }
}
